/*****************************************************************************/
/* EyeClock - A clock application for X. The eyes follow the mouse pointer.  */
/*                                                                           */
/* EyeClock Copyright (C) 1998-1999 Sakai Hiroaki.                           */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* EyeClock is a simple clock application for X11. You can put your favorite */
/* picture on the face of the clock. And you can move the eyes of the        */
/* picture following the mouse pointer.                                      */
/*                                                                           */
/* This file is a part of EyeClock.                                          */
/* EyeClock is FREE SOFTWARE. You can use, copy, modify, and/or redistribute */
/* it freely under the terms in the COPYRIGHT.                               */
/* See the COPYRIGHT for more details.                                       */
/*****************************************************************************/

/*****************************************************************************/
/* Eye å                                                          */
/* ()                                                            */
/*===========================================================================*/
/* Υե                                                        */
/*---------------------------------------------------------------------------*/
/* Υեϡ󥯥롼ѤΥإåեǤ                  */
/* ѻˤϡΥե򥤥󥯥롼ɤƤ                      */
/*****************************************************************************/

#ifndef _Eye_h_INCLUDED_
#define _Eye_h_INCLUDED_

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

/*****************************************************************************/
/* إåեΥ󥯥롼(ѥ֥åʤ)                            */
/*****************************************************************************/

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Core.h>

/*****************************************************************************/
/* (ѥ֥åʤ)                                              */
/*****************************************************************************/

#ifndef XtNgeometry
#define XtNgeometry "geometry"
#endif
#ifndef XtCGeometry
#define XtCGeometry "Geometry"
#endif

#ifndef XtNactive
#define XtNactive "active"
#endif
#ifndef XtCActive
#define XtCActive "Active"
#endif

#ifndef XtNfillColor
#define XtNfillColor "fillColor"
#endif
#ifndef XtCFillColor
#define XtCFillColor "FillColor"
#endif

#ifndef XtNfillPixmap
#define XtNfillPixmap "fillPixmap"
#endif
#ifndef XtCFillPixmap
#define XtCFillPixmap "FillPixmap"
#endif

#ifndef XtNfaceSize
#define XtNfaceSize "faceSize"
#endif
#ifndef XtCFaceSize
#define XtCFaceSize "FaceSize"
#endif

#ifndef XtNfaceWidth
#define XtNfaceWidth "faceWidth"
#endif
#ifndef XtCFaceWidth
#define XtCFaceWidth "FaceWidth"
#endif

#ifndef XtNfaceHeight
#define XtNfaceHeight "faceHeight"
#endif
#ifndef XtCFaceHeight
#define XtCFaceHeight "FaceHeight"
#endif

#ifndef XtNcoreFigure
#define XtNcoreFigure "coreFigure"
#endif
#ifndef XtCCoreFigure
#define XtCCoreFigure "CoreFigure"
#endif

#ifndef XtNcoreMask
#define XtNcoreMask "coreMask"
#endif
#ifndef XtCCoreMask
#define XtCCoreMask "CoreMask"
#endif

#ifndef XtNeyeFigure
#define XtNeyeFigure "eyeFigure"
#endif
#ifndef XtCEyeFigure
#define XtCEyeFigure "EyeFigure"
#endif

#ifndef XtNeyeMask
#define XtNeyeMask "eyeMask"
#endif
#ifndef XtCEyeMask
#define XtCEyeMask "EyeMask"
#endif

#ifndef XtNcoreSize
#define XtNcoreSize "coreSize"
#endif
#ifndef XtCCoreSize
#define XtCCoreSize "CoreSize"
#endif

#ifndef XtNeyeSize
#define XtNeyeSize "eyeSize"
#endif
#ifndef XtCEyeSize
#define XtCEyeSize "EyeSize"
#endif

#ifndef XtNmove
#define XtNmove "move"
#endif
#ifndef XtCMove
#define XtCMove "Move"
#endif

#ifndef XtNlimit
#define XtNlimit "limit"
#endif
#ifndef XtCLimit
#define XtCLimit "Limit"
#endif

#ifndef XtNoffset
#define XtNoffset "offset"
#endif
#ifndef XtCOffset
#define XtCOffset "Offset"
#endif

#ifndef XtNratio
#define XtNratio "ratio"
#endif
#ifndef XtCRatio
#define XtCRatio "Ratio"
#endif

#ifndef XtNratioX
#define XtNratioX "ratioX"
#endif
#ifndef XtCRatioX
#define XtCRatioX "RatioX"
#endif

#ifndef XtNratioY
#define XtNratioY "ratioY"
#endif
#ifndef XtCRatioY
#define XtCRatioY "RatioY"
#endif

/*****************************************************************************/
/* (ѥ֥åʤ)                                                */
/*****************************************************************************/

typedef struct _EyeRec * EyeWidget;
typedef struct _EyeClassRec * EyeWidgetClass;

/*****************************************************************************/
/* ѿ(ѥ֥åʤ)                                          */
/*****************************************************************************/

extern WidgetClass eyeWidgetClass;

/*****************************************************************************/
/* ؿ                                                                      */
/*****************************************************************************/

/*===========================================================================*/
/* 饹Υ᥽åɤ                                                    */
/*===========================================================================*/

/*---------------------------------------------------------------------------*/
/*                                                                       */
/*---------------------------------------------------------------------------*/

void EyeDraw(Widget w, Pixmap pixmap, XPoint pointer);

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

#endif

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
