/*****************************************************************************/
/* Eyeeye_clock - A eye_clock application for X. The eyes follow the mouse pointer.  */
/*                                                                           */
/* Eyeeye_clock Copyright (C) 1998-1999 Sakai Hiroaki.                           */
/* All Rights Reserved.                                                      */
/*                                                                           */
/* Eyeeye_clock is a simple eye_clock application for X11. You can put your favorite */
/* picture on the face of the eye_clock. And you can move the eyes of the        */
/* picture following the mouse pointer.                                      */
/*                                                                           */
/* This file is a part of Eyeeye_clock.                                          */
/* Eyeeye_clock is FREE SOFTWARE. You can use, copy, modify, and/or redistribute */
/* it freely under the terms in the COPYRIGHT.                               */
/* See the COPYRIGHT for more details.                                       */
/*****************************************************************************/

/*****************************************************************************/
/* eye_clock åȤѤ뤿Υᥤե졼                          */
/*===========================================================================*/
/* Eyeeye_clock  eye_clock åȤȤ߷פƤΤǡ                    */
/* ץꥱǤդʬ˥åȤȤĥդ뤳Ȥ        */
/* Ǥޤ                                                                */
/* ΥեǤϡeye_clock åȤĥդ뤿                    */
/* toplevel åȤ eye_clock åȤĥդ      */
/* eye_clockStart() ǻפ򥹥ȤXtAppMainLoop() ƤӽФƤޤ     */
/*****************************************************************************/

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

/*****************************************************************************/
/* إåեΥ󥯥롼                                              */
/*****************************************************************************/

#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xatom.h>

#include <stdio.h> 
#include <stdlib.h> 
#include <signal.h> 

#include "Clock.h"
#include "Hand.h"
#include "Number.h"
#include "Eye.h"

#include "converter.h"
#include "etc.h"

#include "fallback_resources.h"

#include "xpm/default_icon_face.xpm"

/*****************************************************************************/
/*                                                                 */
/*****************************************************************************/

/* None */

/*****************************************************************************/
/*                                                                   */
/*****************************************************************************/

/* None */

/*****************************************************************************/
/* ѿ                                                            */
/*****************************************************************************/

/*===========================================================================*/
/* Toplevel Υå                                                   */
/*===========================================================================*/

static Widget toplevel = 0;
static Widget eye_clock = 0;

/*===========================================================================*/
/* Number åȤΥåȤȤ̾                               */
/*===========================================================================*/

static struct {
  char * name;
  int number;
} numbers_default_values[] = {
  {"number1" ,  1}, {"number2" ,  2}, {"number3" ,  3}, {"number4" ,  4},
  {"number5" ,  5}, {"number6" ,  6}, {"number7" ,  7}, {"number8" ,  8},
  {"number9" ,  9}, {"number10", 10}, {"number11", 11}, {"number12", 12},
  {NULL, 0}
};

/*===========================================================================*/
/* Hand åȤΥåȤȤ̾                                 */
/*===========================================================================*/

static struct {
  char * name;
  HandType type;
} hands_default_values[] = {
  {"hour"  , HOUR_HAND},
  {"minute", MINUTE_HAND},
  {"second", SECOND_HAND},
  {NULL, OTHER_TYPE}
};

/*===========================================================================*/
/* Eye åȤΥåȤȤ̾                                  */
/*===========================================================================*/

static char * eyes_name[] = {
  "left", "right", "eye3", "eye4", "eye5", "eye6", "eye7", "eye8", NULL};

/*===========================================================================*/
/* ץ                                                          */
/*===========================================================================*/

static XrmOptionDescRec options[] = {

  {"-icon-pixmap",        "*iconPixmap",               XrmoptionSepArg, NULL},
  {"-icon-mask",          "*iconMask",                 XrmoptionSepArg, NULL},

  /* eye_clock åѤΥץ */

  {"-eye_clock-geometry",     "*eye_clock.geometry",           XrmoptionSepArg, NULL},
  {"-root",               "*eye_clock.root",               XrmoptionNoArg,"True"},
  {"-no-root",            "*eye_clock.root",               XrmoptionNoArg,"False"},
  {"-face",               "*eye_clock.face",               XrmoptionSepArg, NULL},
  {"-interval",           "*eye_clock.interval",           XrmoptionSepArg, NULL},

  /* Hand åѤΥץ */

  {"-hands-geometry",     "*eye_clock.Hand.geometry",      XrmoptionSepArg, NULL},
  {"-hands-active",       "*eye_clock.Hand.active",        XrmoptionNoArg,"True"},
  {"-hands-no-active",    "*eye_clock.Hand.active",        XrmoptionNoArg,"False"},
  {"-hands-foreground",   "*eye_clock.Hand.foreground",    XrmoptionSepArg, NULL},
  {"-hands-fg",           "*eye_clock.Hand.foreground",    XrmoptionSepArg, NULL},
  {"-hands-bordercolor",  "*eye_clock.Hand.borderColor",   XrmoptionSepArg, NULL},
  {"-hands-bc",           "*eye_clock.Hand.borderColor",   XrmoptionSepArg, NULL},
  {"-hands-borderwidth",  "*eye_clock.Hand.borderWidth",   XrmoptionSepArg, NULL},
  {"-hands-bw",           "*eye_clock.Hand.borderWidth",   XrmoptionSepArg, NULL},
  {"-hands-width",        "*eye_clock.Hand.width",         XrmoptionSepArg, NULL},
  {"-hands-length",       "*eye_clock.Hand.length",        XrmoptionSepArg, NULL},
  {"-hands-type",         "*eye_clock.Hand.type",          XrmoptionSepArg, NULL},

  {"-hour-geometry",      "*eye_clock.hour.geometry",      XrmoptionSepArg, NULL},
  {"-hour-active",        "*eye_clock.hour.active",        XrmoptionNoArg,"True"},
  {"-hour-no-active",     "*eye_clock.hour.active",        XrmoptionNoArg,"False"},
  {"-hour-foreground",    "*eye_clock.hour.foreground",    XrmoptionSepArg, NULL},
  {"-hour-fg",            "*eye_clock.hour.foreground",    XrmoptionSepArg, NULL},
  {"-hour-bordercolor",   "*eye_clock.hour.borderColor",   XrmoptionSepArg, NULL},
  {"-hour-bc",            "*eye_clock.hour.borderColor",   XrmoptionSepArg, NULL},
  {"-hour-borderwidth",   "*eye_clock.hour.borderWidth",   XrmoptionSepArg, NULL},
  {"-hour-bw",            "*eye_clock.hour.borderWidth",   XrmoptionSepArg, NULL},
  {"-hour-width",         "*eye_clock.hour.width",         XrmoptionSepArg, NULL},
  {"-hour-length",        "*eye_clock.hour.length",        XrmoptionSepArg, NULL},
  {"-hour-type",          "*eye_clock.hour.type",          XrmoptionSepArg, NULL},

  {"-minute-geometry",    "*eye_clock.minute.geometry",    XrmoptionSepArg, NULL},
  {"-minute-active",      "*eye_clock.minute.active",      XrmoptionNoArg,"True"},
  {"-minute-no-active",   "*eye_clock.minute.active",      XrmoptionNoArg,"False"},
  {"-minute-foreground",  "*eye_clock.minute.foreground",  XrmoptionSepArg, NULL},
  {"-minute-fg",          "*eye_clock.minute.foreground",  XrmoptionSepArg, NULL},
  {"-minute-bordercolor", "*eye_clock.minute.borderColor", XrmoptionSepArg, NULL},
  {"-minute-bc",          "*eye_clock.minute.borderColor", XrmoptionSepArg, NULL},
  {"-minute-borderwidth", "*eye_clock.minute.borderWidth", XrmoptionSepArg, NULL},
  {"-minute-bw",          "*eye_clock.minute.borderWidth", XrmoptionSepArg, NULL},
  {"-minute-width",       "*eye_clock.minute.width",       XrmoptionSepArg, NULL},
  {"-minute-length",      "*eye_clock.minute.length",      XrmoptionSepArg, NULL},
  {"-minute-type",        "*eye_clock.minute.type",        XrmoptionSepArg, NULL},

  {"-second-geometry",    "*eye_clock.second.geometry",    XrmoptionSepArg, NULL},
  {"-second-active",      "*eye_clock.second.active",      XrmoptionNoArg,"True"},
  {"-second-no-active",   "*eye_clock.second.active",      XrmoptionNoArg,"False"},
  {"-second-foreground",  "*eye_clock.second.foreground",  XrmoptionSepArg, NULL},
  {"-second-fg",          "*eye_clock.second.foreground",  XrmoptionSepArg, NULL},
  {"-second-bordercolor", "*eye_clock.second.borderColor", XrmoptionSepArg, NULL},
  {"-second-bc",          "*eye_clock.second.borderColor", XrmoptionSepArg, NULL},
  {"-second-borderwidth", "*eye_clock.second.borderWidth", XrmoptionSepArg, NULL},
  {"-second-bw",          "*eye_clock.second.borderWidth", XrmoptionSepArg, NULL},
  {"-second-width",       "*eye_clock.second.width",       XrmoptionSepArg, NULL},
  {"-second-length",      "*eye_clock.second.length",      XrmoptionSepArg, NULL},
  {"-second-type",        "*eye_clock.second.type",        XrmoptionSepArg, NULL},

  /* Number åѤΥץ */

  {"-numbers-geometry",   "*eye_clock.Number.geometry",    XrmoptionSepArg, NULL},
  {"-numbers-active",     "*eye_clock.Number.active",      XrmoptionNoArg,"True"},
  {"-numbers-no-active",  "*eye_clock.Number.active",      XrmoptionNoArg,"False"},
  {"-numbers-length",     "*eye_clock.Number.length",      XrmoptionSepArg, NULL},
  {"-numbers-figure",     "*eye_clock.Number.figure",      XrmoptionSepArg, NULL},
  {"-numbers-mask",       "*eye_clock.Number.mask",        XrmoptionSepArg, NULL},
  {"-numbers-size",       "*eye_clock.Number.size",        XrmoptionSepArg, NULL},
  {"-numbers-number",     "*eye_clock.Number.number",      XrmoptionSepArg, NULL},

  {"-number1-geometry",   "*eye_clock.number1.geometry",   XrmoptionSepArg, NULL},
  {"-number1-active",     "*eye_clock.number1.active",     XrmoptionNoArg,"True"},
  {"-number1-no-active",  "*eye_clock.number1.active",     XrmoptionNoArg,"False"},
  {"-number1-length",     "*eye_clock.number1.length",     XrmoptionSepArg, NULL},
  {"-number1-figure",     "*eye_clock.number1.figure",     XrmoptionSepArg, NULL},
  {"-number1-mask",       "*eye_clock.number1.mask",       XrmoptionSepArg, NULL},
  {"-number1-size",       "*eye_clock.number1.size",       XrmoptionSepArg, NULL},
  {"-number1-number",     "*eye_clock.number1.number",     XrmoptionSepArg, NULL},

  {"-number2-geometry",   "*eye_clock.number2.geometry",   XrmoptionSepArg, NULL},
  {"-number2-active",     "*eye_clock.number2.active",     XrmoptionNoArg,"True"},
  {"-number2-no-active",  "*eye_clock.number2.active",     XrmoptionNoArg,"False"},
  {"-number2-length",     "*eye_clock.number2.length",     XrmoptionSepArg, NULL},
  {"-number2-figure",     "*eye_clock.number2.figure",     XrmoptionSepArg, NULL},
  {"-number2-mask",       "*eye_clock.number2.mask",       XrmoptionSepArg, NULL},
  {"-number2-size",       "*eye_clock.number2.size",       XrmoptionSepArg, NULL},
  {"-number2-number",     "*eye_clock.number2.number",     XrmoptionSepArg, NULL},

  {"-number3-geometry",   "*eye_clock.number3.geometry",   XrmoptionSepArg, NULL},
  {"-number3-active",     "*eye_clock.number3.active",     XrmoptionNoArg,"True"},
  {"-number3-no-active",  "*eye_clock.number3.active",     XrmoptionNoArg,"False"},
  {"-number3-length",     "*eye_clock.number3.length",     XrmoptionSepArg, NULL},
  {"-number3-figure",     "*eye_clock.number3.figure",     XrmoptionSepArg, NULL},
  {"-number3-mask",       "*eye_clock.number3.mask",       XrmoptionSepArg, NULL},
  {"-number3-size",       "*eye_clock.number3.size",       XrmoptionSepArg, NULL},
  {"-number3-number",     "*eye_clock.number3.number",     XrmoptionSepArg, NULL},

  {"-number4-geometry",   "*eye_clock.number4.geometry",   XrmoptionSepArg, NULL},
  {"-number4-active",     "*eye_clock.number4.active",     XrmoptionNoArg,"True"},
  {"-number4-no-active",  "*eye_clock.number4.active",     XrmoptionNoArg,"False"},
  {"-number4-length",     "*eye_clock.number4.length",     XrmoptionSepArg, NULL},
  {"-number4-figure",     "*eye_clock.number4.figure",     XrmoptionSepArg, NULL},
  {"-number4-mask",       "*eye_clock.number4.mask",       XrmoptionSepArg, NULL},
  {"-number4-size",       "*eye_clock.number4.size",       XrmoptionSepArg, NULL},
  {"-number4-number",     "*eye_clock.number4.number",     XrmoptionSepArg, NULL},

  {"-number5-geometry",   "*eye_clock.number5.geometry",   XrmoptionSepArg, NULL},
  {"-number5-active",     "*eye_clock.number5.active",     XrmoptionNoArg,"True"},
  {"-number5-no-active",  "*eye_clock.number5.active",     XrmoptionNoArg,"False"},
  {"-number5-length",     "*eye_clock.number5.length",     XrmoptionSepArg, NULL},
  {"-number5-figure",     "*eye_clock.number5.figure",     XrmoptionSepArg, NULL},
  {"-number5-mask",       "*eye_clock.number5.mask",       XrmoptionSepArg, NULL},
  {"-number5-size",       "*eye_clock.number5.size",       XrmoptionSepArg, NULL},
  {"-number5-number",     "*eye_clock.number5.number",     XrmoptionSepArg, NULL},

  {"-number6-geometry",   "*eye_clock.number6.geometry",   XrmoptionSepArg, NULL},
  {"-number6-active",     "*eye_clock.number6.active",     XrmoptionNoArg,"True"},
  {"-number6-no-active",  "*eye_clock.number6.active",     XrmoptionNoArg,"False"},
  {"-number6-length",     "*eye_clock.number6.length",     XrmoptionSepArg, NULL},
  {"-number6-figure",     "*eye_clock.number6.figure",     XrmoptionSepArg, NULL},
  {"-number6-mask",       "*eye_clock.number6.mask",       XrmoptionSepArg, NULL},
  {"-number6-size",       "*eye_clock.number6.size",       XrmoptionSepArg, NULL},
  {"-number6-number",     "*eye_clock.number6.number",     XrmoptionSepArg, NULL},

  {"-number7-geometry",   "*eye_clock.number7.geometry",   XrmoptionSepArg, NULL},
  {"-number7-active",     "*eye_clock.number7.active",     XrmoptionNoArg,"True"},
  {"-number7-no-active",  "*eye_clock.number7.active",     XrmoptionNoArg,"False"},
  {"-number7-length",     "*eye_clock.number7.length",     XrmoptionSepArg, NULL},
  {"-number7-figure",     "*eye_clock.number7.figure",     XrmoptionSepArg, NULL},
  {"-number7-mask",       "*eye_clock.number7.mask",       XrmoptionSepArg, NULL},
  {"-number7-size",       "*eye_clock.number7.size",       XrmoptionSepArg, NULL},
  {"-number7-number",     "*eye_clock.number7.number",     XrmoptionSepArg, NULL},

  {"-number8-geometry",   "*eye_clock.number8.geometry",    XrmoptionSepArg, NULL},
  {"-number8-active",     "*eye_clock.number8.active",     XrmoptionNoArg,"True"},
  {"-number8-no-active",  "*eye_clock.number8.active",     XrmoptionNoArg,"False"},
  {"-number8-length",     "*eye_clock.number8.length",     XrmoptionSepArg, NULL},
  {"-number8-figure",     "*eye_clock.number8.figure",     XrmoptionSepArg, NULL},
  {"-number8-mask",       "*eye_clock.number8.mask",       XrmoptionSepArg, NULL},
  {"-number8-size",       "*eye_clock.number8.size",       XrmoptionSepArg, NULL},
  {"-number8-number",     "*eye_clock.number8.number",     XrmoptionSepArg, NULL},

  {"-number9-geometry",   "*eye_clock.number9.geometry",   XrmoptionSepArg, NULL},
  {"-number9-active",     "*eye_clock.number9.active",     XrmoptionNoArg,"True"},
  {"-number9-no-active",  "*eye_clock.number9.active",     XrmoptionNoArg,"False"},
  {"-number9-length",     "*eye_clock.number9.length",     XrmoptionSepArg, NULL},
  {"-number9-figure",     "*eye_clock.number9.figure",     XrmoptionSepArg, NULL},
  {"-number9-mask",       "*eye_clock.number9.mask",       XrmoptionSepArg, NULL},
  {"-number9-size",       "*eye_clock.number9.size",       XrmoptionSepArg, NULL},
  {"-number9-number",     "*eye_clock.number9.number",     XrmoptionSepArg, NULL},

  {"-number10-geometry",  "*eye_clock.number10.geometry",  XrmoptionSepArg, NULL},
  {"-number10-active",    "*eye_clock.number10.active",    XrmoptionNoArg,"True"},
  {"-number10-no-active", "*eye_clock.number10.active",    XrmoptionNoArg,"False"},
  {"-number10-length",    "*eye_clock.number10.length",    XrmoptionSepArg, NULL},
  {"-number10-figure",    "*eye_clock.number10.figure",    XrmoptionSepArg, NULL},
  {"-number10-mask",      "*eye_clock.number10.mask",      XrmoptionSepArg, NULL},
  {"-number10-size",      "*eye_clock.number10.size",      XrmoptionSepArg, NULL},
  {"-number10-number",    "*eye_clock.number10.number",    XrmoptionSepArg, NULL},

  {"-number11-geometry",  "*eye_clock.number11.geometry",  XrmoptionSepArg, NULL},
  {"-number11-active",    "*eye_clock.number11.active",    XrmoptionNoArg,"True"},
  {"-number11-no-active", "*eye_clock.number11.active",    XrmoptionNoArg,"False"},
  {"-number11-length",    "*eye_clock.number11.length",    XrmoptionSepArg, NULL},
  {"-number11-figure",    "*eye_clock.number11.figure",    XrmoptionSepArg, NULL},
  {"-number11-mask",      "*eye_clock.number11.mask",      XrmoptionSepArg, NULL},
  {"-number11-size",      "*eye_clock.number11.size",      XrmoptionSepArg, NULL},
  {"-number11-number",    "*eye_clock.number11.number",    XrmoptionSepArg, NULL},

  {"-number12-geometry",  "*eye_clock.number12.geometry",  XrmoptionSepArg, NULL},
  {"-number12-active",    "*eye_clock.number12.active",    XrmoptionNoArg,"True"},
  {"-number12-no-active", "*eye_clock.number12.active",    XrmoptionNoArg,"False"},
  {"-number12-length",    "*eye_clock.number12.length",    XrmoptionSepArg, NULL},
  {"-number12-figure",    "*eye_clock.number12.figure",    XrmoptionSepArg, NULL},
  {"-number12-mask",      "*eye_clock.number12.mask",      XrmoptionSepArg, NULL},
  {"-number12-size",      "*eye_clock.number12.size",      XrmoptionSepArg, NULL},
  {"-number12-number",    "*eye_clock.number12.number",    XrmoptionSepArg, NULL},

  /* Eye åѤΥץ */

  {"-eyes-geometry",        "*eye_clock.Eye.geometry",     XrmoptionSepArg, NULL},
  {"-eyes-active",          "*eye_clock.Eye.active",       XrmoptionNoArg,"True"},
  {"-eyes-no-active",       "*eye_clock.Eye.active",       XrmoptionNoArg,"False"},
  {"-eyes-fill-color",      "*eye_clock.Eye.fillColor",    XrmoptionNoArg,"True"},
  {"-eyes-no-fill-color",   "*eye_clock.Eye.fillColor",    XrmoptionNoArg,"False"},
  {"-eyes-fill-pixmap",     "*eye_clock.Eye.fillPixmap",   XrmoptionNoArg,"True"},
  {"-eyes-no-fill-pixmap",  "*eye_clock.Eye.fillPixmap",   XrmoptionNoArg,"False"},
  {"-eyes-background",      "*eye_clock.Eye.background",   XrmoptionSepArg, NULL},
  {"-eyes-bg",              "*eye_clock.Eye.background",   XrmoptionSepArg, NULL},
  {"-eyes-move",            "*eye_clock.Eye.move",         XrmoptionSepArg, NULL},
  {"-eyes-limit",           "*eye_clock.Eye.limit",        XrmoptionSepArg, NULL},
  {"-eyes-offset",          "*eye_clock.Eye.offset",       XrmoptionSepArg, NULL},
  {"-eyes-core-figure",     "*eye_clock.Eye.coreFigure",   XrmoptionSepArg, NULL},
  {"-eyes-core-mask",       "*eye_clock.Eye.coreMask",     XrmoptionSepArg, NULL},
  {"-eyes-eye-figure",      "*eye_clock.Eye.eyeFigure",    XrmoptionSepArg, NULL},
  {"-eyes-eye-mask",        "*eye_clock.Eye.eyeMask",      XrmoptionSepArg, NULL},
  {"-eyes-core-size",       "*eye_clock.Eye.coreSize",     XrmoptionSepArg, NULL},
  {"-eyes-eye-size",        "*eye_clock.Eye.eyeSize",      XrmoptionSepArg, NULL},

  {"-left-geometry",        "*eye_clock.left.geometry",    XrmoptionSepArg, NULL},
  {"-left-active",          "*eye_clock.left.active",      XrmoptionNoArg,"True"},
  {"-left-no-active",       "*eye_clock.left.active",      XrmoptionNoArg,"False"},
  {"-left-fill-color",      "*eye_clock.left.fillColor",   XrmoptionNoArg,"True"},
  {"-left-no-fill-color",   "*eye_clock.left.fillColor",   XrmoptionNoArg,"False"},
  {"-left-fill-pixmap",     "*eye_clock.left.fillPixmap",  XrmoptionNoArg,"True"},
  {"-left-no-fill-pixmap",  "*eye_clock.left.fillPixmap",  XrmoptionNoArg,"False"},
  {"-left-background",      "*eye_clock.left.background",  XrmoptionSepArg, NULL},
  {"-left-bg",              "*eye_clock.left.background",  XrmoptionSepArg, NULL},
  {"-left-move",            "*eye_clock.left.move",        XrmoptionSepArg, NULL},
  {"-left-limit",           "*eye_clock.left.limit",       XrmoptionSepArg, NULL},
  {"-left-offset",          "*eye_clock.left.offset",      XrmoptionSepArg, NULL},
  {"-left-core-figure",     "*eye_clock.left.coreFigure",  XrmoptionSepArg, NULL},
  {"-left-core-mask",       "*eye_clock.left.coreMask",    XrmoptionSepArg, NULL},
  {"-left-eye-figure",      "*eye_clock.left.eyeFigure",   XrmoptionSepArg, NULL},
  {"-left-eye-mask",        "*eye_clock.left.eyeMask",     XrmoptionSepArg, NULL},
  {"-left-core-size",       "*eye_clock.left.coreSize",    XrmoptionSepArg, NULL},
  {"-left-eye-size",        "*eye_clock.left.eyeSize",     XrmoptionSepArg, NULL},

  {"-right-geometry",       "*eye_clock.right.geometry",   XrmoptionSepArg, NULL},
  {"-right-active",         "*eye_clock.right.active",     XrmoptionNoArg,"True"},
  {"-right-no-active",      "*eye_clock.right.active",     XrmoptionNoArg,"False"},
  {"-right-fill-color",     "*eye_clock.right.fillColor",  XrmoptionNoArg,"True"},
  {"-right-no-fill-color",  "*eye_clock.right.fillColor",  XrmoptionNoArg,"False"},
  {"-right-fill-pixmap",    "*eye_clock.right.fillPixmap", XrmoptionNoArg,"True"},
  {"-right-no-fill-pixmap", "*eye_clock.right.fillPixmap", XrmoptionNoArg,"False"},
  {"-right-background",     "*eye_clock.right.background", XrmoptionSepArg, NULL},
  {"-right-bg",             "*eye_clock.right.background", XrmoptionSepArg, NULL},
  {"-right-move",           "*eye_clock.right.move",       XrmoptionSepArg, NULL},
  {"-right-limit",          "*eye_clock.right.limit",      XrmoptionSepArg, NULL},
  {"-right-offset",         "*eye_clock.right.offset",     XrmoptionSepArg, NULL},
  {"-right-core-figure",    "*eye_clock.right.coreFigure", XrmoptionSepArg, NULL},
  {"-right-core-mask",      "*eye_clock.right.coreMask",   XrmoptionSepArg, NULL},
  {"-right-eye-figure",     "*eye_clock.right.eyeFigure",  XrmoptionSepArg, NULL},
  {"-right-eye-mask",       "*eye_clock.right.eyeMask",    XrmoptionSepArg, NULL},
  {"-right-core-size",      "*eye_clock.right.coreSize",   XrmoptionSepArg, NULL},
  {"-right-eye-size",       "*eye_clock.right.eyeSize",    XrmoptionSepArg, NULL},

  {"-eye3-geometry",        "*eye_clock.eye3.geometry",    XrmoptionSepArg, NULL},
  {"-eye3-active",          "*eye_clock.eye3.active",      XrmoptionNoArg,"True"},
  {"-eye3-no-active",       "*eye_clock.eye3.active",      XrmoptionNoArg,"False"},
  {"-eye3-fill-color",      "*eye_clock.eye3.fillColor",   XrmoptionNoArg,"True"},
  {"-eye3-no-fill-color",   "*eye_clock.eye3.fillColor",   XrmoptionNoArg,"False"},
  {"-eye3-fill-pixmap",     "*eye_clock.eye3.fillPixmap" , XrmoptionNoArg,"True"},
  {"-eye3-no-fill-pixmap",  "*eye_clock.eye3.fillPixmap",  XrmoptionNoArg,"False"},
  {"-eye3-background",      "*eye_clock.eye3.background",  XrmoptionSepArg, NULL},
  {"-eye3-bg",              "*eye_clock.eye3.background",  XrmoptionSepArg, NULL},
  {"-eye3-move",            "*eye_clock.eye3.move",        XrmoptionSepArg, NULL},
  {"-eye3-limit",           "*eye_clock.eye3.limit",       XrmoptionSepArg, NULL},
  {"-eye3-offset",          "*eye_clock.eye3.offset",      XrmoptionSepArg, NULL},
  {"-eye3-core-figure",     "*eye_clock.eye3.coreFigure",  XrmoptionSepArg, NULL},
  {"-eye3-core-mask",       "*eye_clock.eye3.coreMask",    XrmoptionSepArg, NULL},
  {"-eye3-eye-figure",      "*eye_clock.eye3.eyeFigure",   XrmoptionSepArg, NULL},
  {"-eye3-eye-mask",        "*eye_clock.eye3.eyeMask",     XrmoptionSepArg, NULL},
  {"-eye3-core-size",       "*eye_clock.eye3.coreSize",    XrmoptionSepArg, NULL},
  {"-eye3-eye-size",        "*eye_clock.eye3.eyeSize",     XrmoptionSepArg, NULL},

  {"-eye4-geometry",        "*eye_clock.eye4.geometry",    XrmoptionSepArg, NULL},
  {"-eye4-active",          "*eye_clock.eye4.active",      XrmoptionNoArg,"True"},
  {"-eye4-no-active",       "*eye_clock.eye4.active",      XrmoptionNoArg,"False"},
  {"-eye4-fill-color",      "*eye_clock.eye4.fillColor",   XrmoptionNoArg,"True"},
  {"-eye4-no-fill-color",   "*eye_clock.eye4.fillColor",   XrmoptionNoArg,"False"},
  {"-eye4-fill-pixmap",     "*eye_clock.eye4.fillPixmap" , XrmoptionNoArg,"True"},
  {"-eye4-no-fill-pixmap",  "*eye_clock.eye4.fillPixmap",  XrmoptionNoArg,"False"},
  {"-eye4-background",      "*eye_clock.eye4.background",  XrmoptionSepArg, NULL},
  {"-eye4-bg",              "*eye_clock.eye4.background",  XrmoptionSepArg, NULL},
  {"-eye4-move",            "*eye_clock.eye4.move",        XrmoptionSepArg, NULL},
  {"-eye4-limit",           "*eye_clock.eye4.limit",       XrmoptionSepArg, NULL},
  {"-eye4-offset",          "*eye_clock.eye4.offset",      XrmoptionSepArg, NULL},
  {"-eye4-core-figure",     "*eye_clock.eye4.coreFigure",  XrmoptionSepArg, NULL},
  {"-eye4-core-mask",       "*eye_clock.eye4.coreMask",    XrmoptionSepArg, NULL},
  {"-eye4-eye-figure",      "*eye_clock.eye4.eyeFigure",   XrmoptionSepArg, NULL},
  {"-eye4-eye-mask",        "*eye_clock.eye4.eyeMask",     XrmoptionSepArg, NULL},
  {"-eye4-core-size",       "*eye_clock.eye4.coreSize",    XrmoptionSepArg, NULL},
  {"-eye4-eye-size",        "*eye_clock.eye4.eyeSize",     XrmoptionSepArg, NULL},

  {"-eye5-geometry",        "*eye_clock.eye5.geometry",    XrmoptionSepArg, NULL},
  {"-eye5-active",          "*eye_clock.eye5.active",      XrmoptionNoArg,"True"},
  {"-eye5-no-active",       "*eye_clock.eye5.active",      XrmoptionNoArg,"False"},
  {"-eye5-fill-color",      "*eye_clock.eye5.fillColor",   XrmoptionNoArg,"True"},
  {"-eye5-no-fill-color",   "*eye_clock.eye5.fillColor",   XrmoptionNoArg,"False"},
  {"-eye5-fill-pixmap",     "*eye_clock.eye5.fillPixmap" , XrmoptionNoArg,"True"},
  {"-eye5-no-fill-pixmap",  "*eye_clock.eye5.fillPixmap",  XrmoptionNoArg,"False"},
  {"-eye5-background",      "*eye_clock.eye5.background",  XrmoptionSepArg, NULL},
  {"-eye5-bg",              "*eye_clock.eye5.background",  XrmoptionSepArg, NULL},
  {"-eye5-move",            "*eye_clock.eye5.move",        XrmoptionSepArg, NULL},
  {"-eye5-limit",           "*eye_clock.eye5.limit",       XrmoptionSepArg, NULL},
  {"-eye5-offset",          "*eye_clock.eye5.offset",      XrmoptionSepArg, NULL},
  {"-eye5-core-figure",     "*eye_clock.eye5.coreFigure",  XrmoptionSepArg, NULL},
  {"-eye5-core-mask",       "*eye_clock.eye5.coreMask",    XrmoptionSepArg, NULL},
  {"-eye5-eye-figure",      "*eye_clock.eye5.eyeFigure",   XrmoptionSepArg, NULL},
  {"-eye5-eye-mask",        "*eye_clock.eye5.eyeMask",     XrmoptionSepArg, NULL},
  {"-eye5-core-size",       "*eye_clock.eye5.coreSize",    XrmoptionSepArg, NULL},
  {"-eye5-eye-size",        "*eye_clock.eye5.eyeSize",     XrmoptionSepArg, NULL},

  {"-eye6-geometry",        "*eye_clock.eye6.geometry",    XrmoptionSepArg, NULL},
  {"-eye6-active",          "*eye_clock.eye6.active",      XrmoptionNoArg,"True"},
  {"-eye6-no-active",       "*eye_clock.eye6.active",      XrmoptionNoArg,"False"},
  {"-eye6-fill-color",      "*eye_clock.eye6.fillColor",   XrmoptionNoArg,"True"},
  {"-eye6-no-fill-color",   "*eye_clock.eye6.fillColor",   XrmoptionNoArg,"False"},
  {"-eye6-fill-pixmap",     "*eye_clock.eye6.fillPixmap" , XrmoptionNoArg,"True"},
  {"-eye6-no-fill-pixmap",  "*eye_clock.eye6.fillPixmap",  XrmoptionNoArg,"False"},
  {"-eye6-background",      "*eye_clock.eye6.background",  XrmoptionSepArg, NULL},
  {"-eye6-bg",              "*eye_clock.eye6.background",  XrmoptionSepArg, NULL},
  {"-eye6-move",            "*eye_clock.eye6.move",        XrmoptionSepArg, NULL},
  {"-eye6-limit",           "*eye_clock.eye6.limit",       XrmoptionSepArg, NULL},
  {"-eye6-offset",          "*eye_clock.eye6.offset",      XrmoptionSepArg, NULL},
  {"-eye6-core-figure",     "*eye_clock.eye6.coreFigure",  XrmoptionSepArg, NULL},
  {"-eye6-core-mask",       "*eye_clock.eye6.coreMask",    XrmoptionSepArg, NULL},
  {"-eye6-eye-figure",      "*eye_clock.eye6.eyeFigure",   XrmoptionSepArg, NULL},
  {"-eye6-eye-mask",        "*eye_clock.eye6.eyeMask",     XrmoptionSepArg, NULL},
  {"-eye6-core-size",       "*eye_clock.eye6.coreSize",    XrmoptionSepArg, NULL},
  {"-eye6-eye-size",        "*eye_clock.eye6.eyeSize",     XrmoptionSepArg, NULL},

  {"-eye7-geometry",        "*eye_clock.eye7.geometry",    XrmoptionSepArg, NULL},
  {"-eye7-active",          "*eye_clock.eye7.active",      XrmoptionNoArg,"True"},
  {"-eye7-no-active",       "*eye_clock.eye7.active",      XrmoptionNoArg,"False"},
  {"-eye7-fill-color",      "*eye_clock.eye7.fillColor",   XrmoptionNoArg,"True"},
  {"-eye7-no-fill-color",   "*eye_clock.eye7.fillColor",   XrmoptionNoArg,"False"},
  {"-eye7-fill-pixmap",     "*eye_clock.eye7.fillPixmap" , XrmoptionNoArg,"True"},
  {"-eye7-no-fill-pixmap",  "*eye_clock.eye7.fillPixmap",  XrmoptionNoArg,"False"},
  {"-eye7-background",      "*eye_clock.eye7.background",  XrmoptionSepArg, NULL},
  {"-eye7-bg",              "*eye_clock.eye7.background",  XrmoptionSepArg, NULL},
  {"-eye7-move",            "*eye_clock.eye7.move",        XrmoptionSepArg, NULL},
  {"-eye7-limit",           "*eye_clock.eye7.limit",       XrmoptionSepArg, NULL},
  {"-eye7-offset",          "*eye_clock.eye7.offset",      XrmoptionSepArg, NULL},
  {"-eye7-core-figure",     "*eye_clock.eye7.coreFigure",  XrmoptionSepArg, NULL},
  {"-eye7-core-mask",       "*eye_clock.eye7.coreMask",    XrmoptionSepArg, NULL},
  {"-eye7-eye-figure",      "*eye_clock.eye7.eyeFigure",   XrmoptionSepArg, NULL},
  {"-eye7-eye-mask",        "*eye_clock.eye7.eyeMask",     XrmoptionSepArg, NULL},
  {"-eye7-core-size",       "*eye_clock.eye7.coreSize",    XrmoptionSepArg, NULL},
  {"-eye7-eye-size",        "*eye_clock.eye7.eyeSize",     XrmoptionSepArg, NULL},

  {"-eye8-geometry",        "*eye_clock.eye8.geometry",    XrmoptionSepArg, NULL},
  {"-eye8-active",          "*eye_clock.eye8.active",      XrmoptionNoArg,"True"},
  {"-eye8-no-active",       "*eye_clock.eye8.active",      XrmoptionNoArg,"False"},
  {"-eye8-fill-color",      "*eye_clock.eye8.fillColor",   XrmoptionNoArg,"True"},
  {"-eye8-no-fill-color",   "*eye_clock.eye8.fillColor",   XrmoptionNoArg,"False"},
  {"-eye8-fill-pixmap",     "*eye_clock.eye8.fillPixmap" , XrmoptionNoArg,"True"},
  {"-eye8-no-fill-pixmap",  "*eye_clock.eye8.fillPixmap",  XrmoptionNoArg,"False"},
  {"-eye8-background",      "*eye_clock.eye8.background",  XrmoptionSepArg, NULL},
  {"-eye8-bg",              "*eye_clock.eye8.background",  XrmoptionSepArg, NULL},
  {"-eye8-move",            "*eye_clock.eye8.move",        XrmoptionSepArg, NULL},
  {"-eye8-limit",           "*eye_clock.eye8.limit",       XrmoptionSepArg, NULL},
  {"-eye8-offset",          "*eye_clock.eye8.offset",      XrmoptionSepArg, NULL},
  {"-eye8-core-figure",     "*eye_clock.eye8.coreFigure",  XrmoptionSepArg, NULL},
  {"-eye8-core-mask",       "*eye_clock.eye8.coreMask",    XrmoptionSepArg, NULL},
  {"-eye8-eye-figure",      "*eye_clock.eye8.eyeFigure",   XrmoptionSepArg, NULL},
  {"-eye8-eye-mask",        "*eye_clock.eye8.eyeMask",     XrmoptionSepArg, NULL},
  {"-eye8-core-size",       "*eye_clock.eye8.coreSize",    XrmoptionSepArg, NULL},
  {"-eye8-eye-size",        "*eye_clock.eye8.eyeSize",     XrmoptionSepArg, NULL}
};

/*===========================================================================*/
/* ȥ                                                                    */
/*===========================================================================*/

static Atom wm_delete_window;

/*===========================================================================*/
/*                                                           */
/*===========================================================================*/

static void quit(Widget w, XEvent * event, String * params, Cardinal * num);
static void wm_quit(Widget w, XEvent * event, String * params, Cardinal * num);
static void restore(Widget w, XEvent * event, String * params, Cardinal * num);
static void iconify(Widget w, XEvent * event, String * params, Cardinal * num);

static XtActionsRec actions[] = {
  {"quit", quit},
  {"wm_quit", wm_quit},
  {"iconify", iconify},
  {"restore", restore}
};

/*===========================================================================*/
/* ȥ󥹥졼                                                  */
/*===========================================================================*/

static char * translations =
"<Message>WM_PROTOCOLS: wm_quit()\n"
"None<Key>r: restore()\n"
"None<Key>i: iconify()\n"
"Ctrl<Key>c: quit()\n"
"None<Key>q: quit()";

/*===========================================================================*/
/* إ                                                                    */
/*===========================================================================*/

static char * help_message =
"\n"
VERSION "\n"
"\n"
"Eyeeye_clock - A eye_clock application for X. The eyes follow the mouse pointer.\n"
"\n"
"Eyeeye_clock Copyright (C) 1998-1999 Sakai Hiroaki.\n"
"All Rights Reserved.\n"
"\n"
"Eyeeye_clock is a simple eye_clock application for X11. You can put your favorite\n"
"picture on the face of the eye_clock. And you can move the eyes of the\n"
"picture following the mouse pointer.\n"
"\n"
"Usage:\n"
"\n"
"        eyeeye_clock [options]\n"
"\n"
"Options:\n"
"\n"
"        (X Toolkit options)\n"
"\n"
"        -display [displayname]\n"
"        -geometry [WxH+X+Y]\n"
"        -title [titlename]\n"
"        -name [name]\n"
"        -background [color], -bg [color]\n"
"        -icon-pixmap [XPM file]\n"
"        -icon-mask [XPM file]\n"
"\n"
"        -eye_clock-geometry [WxH+X+Y]\n"
"        -root\n"
"        -no-root\n"
"        -face [XPM file]\n"
"        -interval [milli seconds]\n"
"\n"
"        -hands-geometry [TxL+X+Y]\n"
"        -hands-active\n"
"        -hands-no-active\n"
"        -hands-foreground [color], -hands-fg [color]\n"
"        -hands-bordercolor [color], -hands-bc [color]\n"
"        -hands-borderwidth [x], -hands-bw [x]\n"
"        -hands-width [x]\n"
"        -hands-length [x]\n"
"\n"
"        Options like \"-hour-XXXXXXXX\", \"-minute-XXXXXXXX\", and,\n"
"        \"-second-XXXXXXXX\" are equal to above options. Option like\n"
"        \"-hands-XXXXXXXX\" effects all hands. Option like\n"
"        \"-hour-XXXXXXXX\" effects only hour hand.\n"
"\n"
"        -numbers-geometry [WxH+X+Y]\n"
"        -numbers-active\n"
"        -numbers-no-active\n"
"        -numbers-length [x]\n"
"        -numbers-figure [XPM file]\n"
"        -numbers-mask [XPM file]\n"
"        -numbers-size [WxH]\n"
"\n"
"        Options like \"-number1-XXXXXXXX\", \"-number2-XXXXXXXX\", ...,\n"
"        and, \"-number12-XXXXXXXX\" are equal to above options.\n"
"        Option like \"-numbers-XXXXXXXX\" effects all numbers.\n"
"        Option like \"-number1-XXXXXXXX\" effects only number 1.\n"
"\n"
"        -eyes-geometry [WxH+X+Y]\n"
"        -eyes-active\n"
"        -eyes-no-active\n"
"        -eyes-fill-color\n"
"        -eyes-no-fill-color\n"
"        -eyes-fill-pixmap\n"
"        -eyes-no-fill-pixmap\n"
"        -eyes-background [color], -eyes-bg [color]\n"
"        -eyes-move [XxY]\n"
"        -eyes-limit [XxY]\n"
"        -eyes-offset [XxY]\n"
"        -eyes-core-figure [XPM file]\n"
"        -eyes-core-mask [XPM file]\n"
"        -eyes-eye-figure [XPM file]\n"
"        -eyes-eye-mask [XPM file]\n"
"        -eyes-core-size [WxH]\n"
"        -eyes-eye-size [WxH]\n"
"\n"
"        Options like \"-left-XXXXXXXX\", \"-right-XXXXXXXX\",\n"
"        \"-eye3-XXXXXXXX\", ... , and, \"-eye8-XXXXXXXX\" are equal to\n"
"        above options. Option like \"-eyes-XXXXXXXX\" effects all\n"
"        eyes. Option like \"-left-XXXXXXXX\" effects only left eye.\n"
"\n"
"See \"man eyeeye_clock\" for more details.\n"
"\n"
;

/*****************************************************************************/
/* ؿ                                                                */
/*****************************************************************************/

/*===========================================================================*/
/* λ                                                                  */
/*===========================================================================*/

static void die(Widget w)
{
  Display * display;
  int i;

  if (eye_clock)
    if (XtIsRealized(eye_clock))
      ClockStop(eye_clock);

  if (toplevel)
    if (XtIsRealized(toplevel)) {
      display = XtDisplay(toplevel);
      XtDestroyWidget(toplevel);
      XCloseDisplay(display);
    }

  exit(0);
}

static void quit(Widget w, XEvent * event, String * params, Cardinal * num)
{
  die(w);
}

static void wm_quit(Widget w, XEvent * event, String * params, Cardinal * num)
{
  if ((event->type == ClientMessage) && 
      (event->xclient.data.l[0] != wm_delete_window)) {
    XBell(XtDisplay(w), 0);
  } else {
    die(w);
  }
}

static void restore(Widget w, XEvent * event, String * params, Cardinal * num)
{
  unsigned int width;
  unsigned int height;

  width  = ClockGetFaceWidth(eye_clock);
  height = ClockGetFaceHeight(eye_clock);

  if (width && height)
    XtVaSetValues(toplevel, XtNwidth, width, XtNheight, height, NULL);
}

static void iconify(Widget w, XEvent * event, String * params, Cardinal * num)
{
  XIconifyWindow(XtDisplay(toplevel), XtWindow(toplevel),
		 DefaultScreen(XtDisplay(toplevel)));
}

/*===========================================================================*/
/* Ctrl-c ϥɥ                                                           */
/*===========================================================================*/

static void interrupt_handler(int value)
{
  die(toplevel);
}

/*===========================================================================*/
/* HUP ʥϥɥ                                                      */
/*===========================================================================*/

static void hup_handler(int value)
{
  XRaiseWindow(XtDisplay(toplevel), XtWindow(toplevel));
}

/*===========================================================================*/
/* إ                                                                    */
/*===========================================================================*/

static void help()
{
  fprintf(stdout, "%s", help_message);
  die(toplevel);
}

/*===========================================================================*/
/* ᥤ                                                                    */
/*===========================================================================*/

int main(int argc, char * argv[])
{
  XtAppContext app_context;
  Display * display;
  Window root;
  Pixmap pixmap;
  Pixmap icon_face;
  Pixmap icon_mask;
  int i;

  /* ꥽СϿ */
  XtSetTypeConverter(XtRString, XtRXPoint, ConvertStringToPoint,
                     NULL, 0, XtCacheNone, NULL);
  XtSetTypeConverter(XtRString, XtRBitmap, ConvertStringToPixmap,
                     NULL, 0, XtCacheNone, NULL);
  XtSetTypeConverter(XtRString, XtRPixmap, ConvertStringToPixmap,
                     NULL, 0, XtCacheNone, NULL);
  XtSetTypeConverter(XtRPixmapData, XtRPixmap, ConvertPixmapDataToPixmap,
                     NULL, 0, XtCacheNone, NULL);
  XtSetTypeConverter(XtRString, XtRWidgetCorePart, 
                     ConvertGeometryStringToPoint, NULL, 0,
                     XtCacheNone, NULL);

  /* ȥåץ٥åȤκ */
  toplevel = XtAppInitialize(&app_context, "Eyeeye_clock",
			     options, XtNumber(options),
			     &argc, argv, fallback_resources, NULL, 0);

  if (argc > 1) {
    for (i = 1; i < argc; i++)
      fprintf(stderr, "Unknown option : %s\n", argv[i]);
    help();
  }

  /* eye_clock åȤκ */
  eye_clock = XtCreateManagedWidget("eye_clock", clockWidgetClass, toplevel, NULL, 0);

  /* Hand åȤκ */
  for (i = 0; hands_default_values[i].name; i++)
    XtVaCreateManagedWidget(hands_default_values[i].name,
			    handWidgetClass, eye_clock,
			    XtNtype, hands_default_values[i].type, NULL);

  /* Number åȤκ */
  for (i = 0; numbers_default_values[i].name; i++)
    XtVaCreateManagedWidget(numbers_default_values[i].name,
			    numberWidgetClass, eye_clock,
			    XtNnumber, numbers_default_values[i].number, NULL);

  /* Eye åȤκ */
  for (i = 0; eyes_name[i]; i++)
    XtCreateManagedWidget(eyes_name[i], eyeWidgetClass, eye_clock, NULL, 0);

  /* ݥ󥿤Υեͭˤ */
  XtVaSetValues(toplevel, XtNinput, True, NULL);

  display = XtDisplay(toplevel);
  root = DefaultRootWindow(display);

  /*  */
  XtVaGetValues(toplevel, XtNiconPixmap, &icon_face, NULL);
  if (icon_face == 0) {
    icon_face = MakePixmapFromPixmapData(display, root, icon_face_xpm);
    XtVaSetValues(toplevel, XtNiconPixmap, icon_face, NULL);
  }

  /* ޥ */
  XtVaGetValues(toplevel, XtNiconMask, &pixmap, NULL);
  if (pixmap)
    icon_mask = CreateInvertMaskBitmap(display, root, pixmap);
  else
    icon_mask = CreateInvertMaskBitmap(display, root, icon_face);
  XtVaSetValues(toplevel, XtNiconMask, icon_mask, NULL);
  if (pixmap)
    XFreePixmap(display, pixmap);

  /*  */
  XtAppAddActions(app_context, actions, XtNumber(actions));

  /* ȥ󥹥졼 */
  XtOverrideTranslations(toplevel, XtParseTranslationTable(translations));

  /* åȤΥꥢ饤 */
  XtRealizeWidget(toplevel);

  /* X ФåȤꥢ饤ޤԤ */
  while (!XtIsRealized(toplevel)) { /* None */ }

  /* ɥޥ͡㤫 f.delete ؤб */
  wm_delete_window = XInternAtom(display, "WM_DELETE_WINDOW", False);
  XSetWMProtocols(display, XtWindow(toplevel), &wm_delete_window, 1);

  /* פ򥹥Ȥ */
  ClockStart(app_context, eye_clock);

  /* Ctrl-c Υȥå */
  signal(SIGINT, interrupt_handler);

  /* HUP ʥΥȥå */
  signal(SIGHUP, hup_handler);

  /* ᥤ롼 */
  XtAppMainLoop(app_context);
}

/*****************************************************************************/
/* ޤ                                                                  */
/*****************************************************************************/

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
